package com.dzeio.openhealth.utils.fields

import android.content.Context
import android.text.InputType
import android.text.TextUtils
import android.util.AttributeSet
import android.util.Log
import android.widget.EditText
import androidx.preference.EditTextPreference

/**
 * TOTALLY BASED on stolen code from stackoverflow that I don't remember where... f*ck
 *
 * Basically it allows to change the way `EditTextPreference` works to allow only numbers
 */
class IntEditTextPreference : EditTextPreference, EditTextPreference.OnBindEditTextListener {

    private var txt: String? = null

    constructor(
        context: Context,
        attrs: AttributeSet?,
        defStyleAttr: Int,
        defStyleRes: Int
    ) : super(context, attrs, defStyleAttr, defStyleRes) {
        setOnBindEditTextListener(this)
    }

    constructor(context: Context, attrs: AttributeSet?, defStyleAttr: Int) : super(
        context,
        attrs,
        defStyleAttr
    ) {
        setOnBindEditTextListener(this)
    }

    constructor(context: Context, attrs: AttributeSet?) : super(context, attrs) {
        setOnBindEditTextListener(this)
    }

    constructor(context: Context) : super(context) {
        setOnBindEditTextListener(this)
    }

    /**
     * Saves the text to the current data storage.
     *
     * @param text The text to save
     */
    override fun setText(text: String?) {

        val wasBlocking = shouldDisableDependents()
        val pouet = Integer.parseInt(text.toString())
        this.txt = text
        pouet::class.simpleName?.let { Log.d("pouet2", it) }
        persistInt(pouet)
        val isBlocking = shouldDisableDependents()
        if (isBlocking != wasBlocking) {
            notifyDependencyChange(isBlocking)
        }
        notifyChanged()
    }

    override fun getText(): String? {
        return this.txt
    }

    override fun onSetInitialValue(defaultValue: Any?) {
        var value: Int
        if (defaultValue != null) {
            val strDefaultValue = defaultValue as String
            val defaultIntValue = strDefaultValue.toInt()
            value = getPersistedInt(defaultIntValue)
        } else {
            try {
                value = getPersistedInt(0)
            } catch (e: ClassCastException) {
                value = 0
            }
        }
        text = value.toString()
    }

    override fun shouldDisableDependents(): Boolean {
        return TextUtils.isEmpty(text) || super.shouldDisableDependents()
    }

    override fun onBindEditText(editText: EditText) {
        editText.inputType = InputType.TYPE_CLASS_NUMBER
    }
}
